searchData={"items":[{"type":"module","title":"GraphqlMarkdown","doc":"Converts a GraphQL JSON schema to a markdown format","ref":"GraphqlMarkdown.html"},{"type":"function","title":"GraphqlMarkdown.generate/1","doc":"Perform the conversion to generate the markdown files","ref":"GraphqlMarkdown.html#generate/1"},{"type":"module","title":"GraphqlMarkdown.MarkdownHelpers","doc":"A set of helpers to generate proper markdown easily","ref":"GraphqlMarkdown.MarkdownHelpers.html"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.anchor/2","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#anchor/2"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.code/1","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#code/1"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.default_value/1","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#default_value/1"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.graphql_operation_code_block/1","doc":"Generates a code block for a GraphQL operation. Only the top-level fields returned are represented in the code block.\nWhen one of the fields returned is an object, the object's fields are not included in the code block.\n\nExample:\n  ```gql\n  mutation RefreshIdToken($refreshToken: String!) {\n    refreshIdToken(refreshToken: $refreshToken) {\n      idToken\n      userSsoDetails {\n      }\n    }\n  }\n  ```\n\n  In this example, the `idToken` field is a scalar, so it is included in the code block.\n  In this example the `userSsoDetails` field is an object, so its fields are not included in the code block.","ref":"GraphqlMarkdown.MarkdownHelpers.html#graphql_operation_code_block/1"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.header/3","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#header/3"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.link/2","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#link/2"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.list/3","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#list/3"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.new_line/0","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#new_line/0"},{"type":"function","title":"GraphqlMarkdown.MarkdownHelpers.table/2","doc":"","ref":"GraphqlMarkdown.MarkdownHelpers.html#table/2"},{"type":"module","title":"GraphqlMarkdown.MultiPage","doc":"Multi page generator from Graphql to Markdown","ref":"GraphqlMarkdown.MultiPage.html"},{"type":"function","title":"GraphqlMarkdown.MultiPage.generate_section/3","doc":"","ref":"GraphqlMarkdown.MultiPage.html#generate_section/3"},{"type":"function","title":"GraphqlMarkdown.MultiPage.render_schema/2","doc":"","ref":"GraphqlMarkdown.MultiPage.html#render_schema/2"},{"type":"module","title":"GraphqlMarkdown.OperationDetailsHelpers","doc":"A set of helpers to generate query and mutation details.","ref":"GraphqlMarkdown.OperationDetailsHelpers.html"},{"type":"function","title":"GraphqlMarkdown.OperationDetailsHelpers.generate_operation_details/3","doc":"Creates a map with the details of a query or mutation. The details created include\nthe operation type, operation name, arguments, and return type.","ref":"GraphqlMarkdown.OperationDetailsHelpers.html#generate_operation_details/3"},{"type":"type","title":"GraphqlMarkdown.OperationDetailsHelpers.argument/0","doc":"","ref":"GraphqlMarkdown.OperationDetailsHelpers.html#t:argument/0"},{"type":"type","title":"GraphqlMarkdown.OperationDetailsHelpers.field/0","doc":"","ref":"GraphqlMarkdown.OperationDetailsHelpers.html#t:field/0"},{"type":"type","title":"GraphqlMarkdown.OperationDetailsHelpers.graphql_operation_details/0","doc":"","ref":"GraphqlMarkdown.OperationDetailsHelpers.html#t:graphql_operation_details/0"},{"type":"type","title":"GraphqlMarkdown.OperationDetailsHelpers.return_type/0","doc":"","ref":"GraphqlMarkdown.OperationDetailsHelpers.html#t:return_type/0"},{"type":"module","title":"GraphqlMarkdown.Renderer","doc":"A Genserver to renderer message to stiod by default or to file if specifying a filename when starting","ref":"GraphqlMarkdown.Renderer.html"},{"type":"function","title":"GraphqlMarkdown.Renderer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GraphqlMarkdown.Renderer.html#child_spec/1"},{"type":"function","title":"GraphqlMarkdown.Renderer.init/1","doc":"","ref":"GraphqlMarkdown.Renderer.html#init/1"},{"type":"function","title":"GraphqlMarkdown.Renderer.render/2","doc":"","ref":"GraphqlMarkdown.Renderer.html#render/2"},{"type":"function","title":"GraphqlMarkdown.Renderer.render_newline/1","doc":"","ref":"GraphqlMarkdown.Renderer.html#render_newline/1"},{"type":"function","title":"GraphqlMarkdown.Renderer.save/1","doc":"","ref":"GraphqlMarkdown.Renderer.html#save/1"},{"type":"function","title":"GraphqlMarkdown.Renderer.start_link/1","doc":"","ref":"GraphqlMarkdown.Renderer.html#start_link/1"},{"type":"module","title":"GraphqlMarkdown.Schema","doc":"Internal Schema representation of Graphql section we care about","ref":"GraphqlMarkdown.Schema.html"},{"type":"function","title":"GraphqlMarkdown.Schema.enum_kind/0","doc":"","ref":"GraphqlMarkdown.Schema.html#enum_kind/0"},{"type":"function","title":"GraphqlMarkdown.Schema.field_kind/1","doc":"","ref":"GraphqlMarkdown.Schema.html#field_kind/1"},{"type":"function","title":"GraphqlMarkdown.Schema.field_type/1","doc":"","ref":"GraphqlMarkdown.Schema.html#field_type/1"},{"type":"function","title":"GraphqlMarkdown.Schema.find_and_sort_type/4","doc":"","ref":"GraphqlMarkdown.Schema.html#find_and_sort_type/4"},{"type":"function","title":"GraphqlMarkdown.Schema.full_field_type/1","doc":"","ref":"GraphqlMarkdown.Schema.html#full_field_type/1"},{"type":"function","title":"GraphqlMarkdown.Schema.input_kind/0","doc":"","ref":"GraphqlMarkdown.Schema.html#input_kind/0"},{"type":"function","title":"GraphqlMarkdown.Schema.interface_kind/0","doc":"","ref":"GraphqlMarkdown.Schema.html#interface_kind/0"},{"type":"function","title":"GraphqlMarkdown.Schema.mutation_type/1","doc":"","ref":"GraphqlMarkdown.Schema.html#mutation_type/1"},{"type":"function","title":"GraphqlMarkdown.Schema.object_kind/0","doc":"","ref":"GraphqlMarkdown.Schema.html#object_kind/0"},{"type":"function","title":"GraphqlMarkdown.Schema.query_type/1","doc":"","ref":"GraphqlMarkdown.Schema.html#query_type/1"},{"type":"function","title":"GraphqlMarkdown.Schema.scalar_kind/0","doc":"","ref":"GraphqlMarkdown.Schema.html#scalar_kind/0"},{"type":"function","title":"GraphqlMarkdown.Schema.schema_from_json/1","doc":"","ref":"GraphqlMarkdown.Schema.html#schema_from_json/1"},{"type":"function","title":"GraphqlMarkdown.Schema.subscription_type/1","doc":"","ref":"GraphqlMarkdown.Schema.html#subscription_type/1"},{"type":"function","title":"GraphqlMarkdown.Schema.types/1","doc":"","ref":"GraphqlMarkdown.Schema.html#types/1"},{"type":"function","title":"GraphqlMarkdown.Schema.union_kind/0","doc":"","ref":"GraphqlMarkdown.Schema.html#union_kind/0"},{"type":"type","title":"GraphqlMarkdown.Schema.t/0","doc":"test","ref":"GraphqlMarkdown.Schema.html#t:t/0"},{"type":"module","title":"GraphqlMarkdown.SinglePage","doc":"Single page generator from Graphql to Markdown","ref":"GraphqlMarkdown.SinglePage.html"},{"type":"function","title":"GraphqlMarkdown.SinglePage.generate_section/3","doc":"","ref":"GraphqlMarkdown.SinglePage.html#generate_section/3"},{"type":"function","title":"GraphqlMarkdown.SinglePage.generate_sections/1","doc":"","ref":"GraphqlMarkdown.SinglePage.html#generate_sections/1"},{"type":"function","title":"GraphqlMarkdown.SinglePage.render_schema/2","doc":"","ref":"GraphqlMarkdown.SinglePage.html#render_schema/2"},{"type":"task","title":"mix graphql_gen_markdown","doc":"A mix task to convert a GraphQL JSON schema to markdown\n\nusage\n-----\n\nmix graphql_gen_markdown [OPTIONS]\n\nvalid override args:\n  -f, --schema            Path to the schema file\n  -o, --output-dir        Where to output the files. Default: [Current Directory]\n  -m, --multi-page        Generate each type in a separate file. Default: [single page format]\n  -t, --title             Specify the page title for the generated file (Applies to single file only)\n  --no-toc                Do not generate the table of content (Applies to single file only)\n\n\nExamples\n--------\n\n1. Convert the GraphQL JSON schema to a single markdown file\n\n```elixir\nmix graphql_gen_markdown -f myschema.json\n```\n\n2. Convert the GraphQL JSON schema to a multiple markdown file\n\n```elixir\nmix graphql_gen_markdown -f myschema.json -m\n```","ref":"Mix.Tasks.GraphqlGenMarkdown.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.4.2 - 2024-09-26 - Changelog","doc":"","ref":"changelog.html#0-4-2-2024-09-26"},{"type":"extras","title":"Fixed - Changelog","doc":"* Links to union return types handled correctly","ref":"changelog.html#fixed"},{"type":"extras","title":"0.4.1 - 2024-09-25 - Changelog","doc":"","ref":"changelog.html#0-4-1-2024-09-25"},{"type":"extras","title":"Fixed - Changelog","doc":"* Links to types from queries/mutations sets anchor properly","ref":"changelog.html#fixed"},{"type":"extras","title":"0.4.0 - 2024-08-26 - Changelog","doc":"","ref":"changelog.html#0-4-0-2024-08-26"},{"type":"extras","title":"Added - Changelog","doc":"* Added support for Subscriptions","ref":"changelog.html#added"},{"type":"extras","title":"0.3.1 - 2024-07-01 - Changelog","doc":"","ref":"changelog.html#0-3-1-2024-07-01"},{"type":"extras","title":"Fixed - Changelog","doc":"* Fix problems with generating example queries and mutations when the return types are unions, interfaces or lists: [#49](https://github.com/podium/graphql_markdown/pull/49)","ref":"changelog.html#fixed"},{"type":"extras","title":"0.3.0 - 2024-06-25 [RETIRED] - Changelog","doc":"","ref":"changelog.html#0-3-0-2024-06-25-retired"},{"type":"extras","title":"Added - Changelog","doc":"* Support generating example queries from the schema","ref":"changelog.html#added"},{"type":"extras","title":"0.2.1 - 2024-03-26 - Changelog","doc":"","ref":"changelog.html#0-2-1-2024-03-26"},{"type":"extras","title":"Changed - Changelog","doc":"* Improve documentation\n* Fix generating multiple times","ref":"changelog.html#changed"},{"type":"extras","title":"0.2.0 - 2024-01-12 - Changelog","doc":"","ref":"changelog.html#0-2-0-2024-01-12"},{"type":"extras","title":"Changed - Changelog","doc":"* Deps Update release","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.5 - 2023-08-16 - Changelog","doc":"","ref":"changelog.html#0-1-5-2023-08-16"},{"type":"extras","title":"Changed - Changelog","doc":"* Added more documentation\n* Fix typespec","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.4 - 2022-09-27 - Changelog","doc":"","ref":"changelog.html#0-1-4-2022-09-27"},{"type":"extras","title":"Changed - Changelog","doc":"* Update dependencies","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.3 - 2021-09-23 - Changelog","doc":"","ref":"changelog.html#0-1-3-2021-09-23"},{"type":"extras","title":"Fixed - Changelog","doc":"* Add missing type and description for mutations and queries","ref":"changelog.html#fixed"},{"type":"extras","title":"0.1.2 - 2021-09-17 - Changelog","doc":"","ref":"changelog.html#0-1-2-2021-09-17"},{"type":"extras","title":"Fixed - Changelog","doc":"* Support for Unions properly\n* Fix breakage when description is nil","ref":"changelog.html#fixed"},{"type":"extras","title":"0.1.1 - 2021-09-17 - Changelog","doc":"","ref":"changelog.html#0-1-1-2021-09-17"},{"type":"extras","title":"Fixed - Changelog","doc":"* Fix wrong link in multi page for scalar/objects","ref":"changelog.html#fixed"},{"type":"extras","title":"0.1 - 2021-09-17 - Changelog","doc":"_Initial release_","ref":"changelog.html#0-1-2021-09-17"},{"type":"extras","title":"Readme","doc":"# GraphqlMarkdown\n\nConverts a JSON Graphql Schema to Markdown","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `graphql_markdown` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:graphql_markdown, \"~> 0.1.2\"}\n  ]\nend\n```\n\nAnd run:\n\n```shell\nmix deps.get\n```\n\nGenerate a single file called `graphql_schema.md` in the current dir:\n\n```shell\nmix graphql_gen_markdown -f ./schema.json\n```\n\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/graphql_markdown](https://hexdocs.pm/graphql_markdown).","ref":"readme.html#installation"},{"type":"extras","title":"Quick Start - Readme","doc":"You can generate either single page with all the types or a multipage that will then generate separately Mutations, Queries, Enums etc, each in a different file.","ref":"readme.html#quick-start"},{"type":"extras","title":"Single page - Readme","doc":"When you run the following\n\n```shell\nmix graphql_gen_markdown -f ./schema.json\n```\nit will generate the following file in your current folder:\n\n./graphql_schema.md\n\nYou can change the default title for the single page with `-t` option.","ref":"readme.html#single-page"},{"type":"extras","title":"Multi pages - Readme","doc":"When you run the following\n\n```shell\nmix graphql_gen_markdown -f ./schema.json -m\n```\n\nit will generate the following files in your current folder:\n\n  ./queries.md\n  ./mutations.md\n  ./subscriptions.md\n  ./objects.md\n  ./inputs.md\n  ./enums.md\n  ./scalars.md\n  ./interfaces.md\n  ./unions.md","ref":"readme.html#multi-pages"},{"type":"extras","title":"Integrate with ExDoc and Absinthe - Readme","doc":"You can easily automate the process with ExDoc by adding the following to your `mix.exs` file:\n\n```elixir\ndefmodule Azeroth.MixProject do\n  use Mix.Project\n\n  # this is needed because the file are generated but if you run mix docs, Mix will check the existence of files first. so have to work around that\n  @graphql_files [\n    \"guides/graphql/enums.md\",\n    \"guides/graphql/inputs.md\",\n    \"guides/graphql/interfaces.md\",\n    \"guides/graphql/mutations.md\",\n    \"guides/graphql/objects.md\",\n    \"guides/graphql/queries.md\",\n    \"guides/graphql/scalars.md\",\n    \"guides/graphql/unions.md\",\n    \"guides/graphql/subscriptions.md\"\n  ]\n  ...\n\n  defp aliases do\n  [\n    docs: [\n      \"absinthe.schema.json\",\n      \"graphql_gen_markdown -f schema.json -o guides/graphql -m\",\n      \"docs\"\n    ],...\n  ]\n```\n\nMake sure the absinthe schema is specified or generated with that name. Or add to your config.exs:\n\n```elixir\nconfig :absinthe, schema: YouApp.GraphQL.Schema\n```","ref":"readme.html#integrate-with-exdoc-and-absinthe"},{"type":"extras","title":"Documentation - Readme","doc":"Documentation is [available on Hexdocs](https://hexdocs.pm/graphql_markdown/)","ref":"readme.html#documentation"},{"type":"extras","title":"Contributing - Readme","doc":"1. [Fork it!](http://github.com/podium/graphql_markdown/fork)\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Commit your changes (`git commit -am 'Add some feature'`)\n4. Push to the branch (`git push origin my-new-feature`)\n5. Create new Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"Author - Readme","doc":"Emmanuel Pinault (@epinault)","ref":"readme.html#author"},{"type":"extras","title":"License - Readme","doc":"GraphqlMarkdown is released under the MIT License. See the [LICENSE.md](LICENSE.md) file for further details.","ref":"readme.html#license"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2021 Emmanuel Pinault\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Contributing","doc":"# Contributing to Graphql Markdown\n\nPlease take a moment to review this document in order to make the contribution\nprocess easy and effective for everyone involved!\nAlso make sure you read our [Code of Conduct](CODE_OF_CONDUCT.md) that outlines our commitment towards an open and welcoming environment.","ref":"contributing.html"},{"type":"extras","title":"Using the issue tracker - Contributing","doc":"Use the issues tracker for:\n\n* [Bug reports](#bug-reports)\n* [Submitting pull requests](#pull-requests)\n\nWe do our best to keep the issue tracker tidy and organized, making it useful\nfor everyone. For example, we classify open issues per perceived difficulty,\nmaking it easier for developers to [contribute to Graphql Markdown](#pull-requests).","ref":"contributing.html#using-the-issue-tracker"},{"type":"extras","title":"Bug reports - Contributing","doc":"A bug is either a _demonstrable problem_ that is caused by the code in the repository,\nor indicate missing, unclear, or misleading documentation. Good bug reports are extremely\nhelpful - thank you!\n\nGuidelines for bug reports:\n\n1. **Use the GitHub issue search** &mdash; check if the issue has already been\n   reported.\n\n2. **Check if the issue has been fixed** &mdash; try to reproduce it using the\n   `master` branch in the repository.\n\n3. **Isolate and report the problem** &mdash; ideally create a reduced test\n   case.\n\nPlease try to be as detailed as possible in your report. Include information about\nyour Operating System, as well as your Erlang, Elixir and Graphql Markdown versions. Please provide steps to\nreproduce the issue as well as the outcome you were expecting! All these details\nwill help developers to fix any potential bugs.\n\nExample:\n\n> Short and descriptive example bug report title\n>\n> A summary of the issue and the environment in which it occurs. If suitable,\n> include the steps required to reproduce the bug.\n>\n> 1. This is the first step\n> 2. This is the second step\n> 3. Further steps, etc.\n>\n> ` ` - a link to the reduced test case (e.g. a GitHub Gist)\n>\n> Any other information you want to share that is relevant to the issue being\n> reported. This might include the lines of code that you have identified as\n> causing the bug, and potential solutions (and your opinions on their\n> merits).","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing Documentation - Contributing","doc":"Code documentation (`@doc`, `@moduledoc`, `@typedoc`) has a special convention:\nthe first paragraph is considered to be a short summary.\n\nFor functions, macros and callbacks say what it will do. For example write\nsomething like:\n\n```elixir\n@doc \"\"\"\nMarks the given value as HTML safe.\n\"\"\"\ndef safe({:safe, value}), do: {:safe, value}\n```\n\nFor modules, protocols and types say what it is. For example write\nsomething like:\n\n```elixir\ndefmodule MyModule do\n  @moduledoc \"\"\"\n  Conveniences for working HTML strings and templates.\n  ...\n  \"\"\"\n```\n\nKeep in mind that the first paragraph might show up in a summary somewhere, long\ntexts in the first paragraph create very ugly summaries. As a rule of thumb\nanything longer than 80 characters is too long.\n\nTry to keep unnecessary details out of the first paragraph, it's only there to\ngive a user a quick idea of what the documented \"thing\" does/is. The rest of the\ndocumentation string can contain the details, for example when a value and when\n`nil` is returned.\n\nIf possible include examples, preferably in a form that works with doctests.\nThis makes it easy to test the examples so that they don't go stale and examples\nare often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation"},{"type":"extras","title":"Pull requests - Contributing","doc":"Good pull requests - patches, improvements, new features - are a fantastic\nhelp. They should remain focused in scope and avoid containing unrelated\ncommits.\n\n**IMPORTANT**: By submitting a patch, you agree that your work will be\nlicensed under the license used by the project.\n\nIf you have any large pull request in mind (e.g. implementing features,\nrefactoring code, etc), **please ask first** otherwise you risk spending\na lot of time working on something that the project's developers might\nnot want to merge into the project.\n\nPlease adhere to the coding conventions in the project (indentation,\naccurate comments, etc.) and don't forget to add your own tests and\ndocumentation. When working with git, we recommend the following process\nin order to craft an excellent pull request:\n\n1. [Fork](https://help.github.com/articles/fork-a-repo/) the project, clone your fork,\n   and configure the remotes:\n\n   ```bash\n   # Clone your fork of the repo into the current directory\n   git clone https://github.com/ /graphql_markdown\n\n   # Navigate to the newly cloned directory\n   cd graphql_markdown\n\n   # Assign the original repo to a remote called \"upstream\"\n   git remote add upstream https://github.com/podium/graphql_markdown\n   ```\n\n2. If you cloned a while ago, get the latest changes from upstream, and update your fork:\n\n   ```bash\n   git checkout master\n   git pull upstream master\n   git push\n   ```\n\n3. Create a new topic branch (off of `master`) to contain your feature, change,\n   or fix.\n\n   **IMPORTANT**: Making changes in `master` is discouraged. You should always\n   keep your local `master` in sync with upstream `master` and make your\n   changes in topic branches.\n\n   ```bash\n   git checkout -b  \n   ```\n\n4. Commit your changes in logical chunks. Keep your commit messages organized,\n   with a short description in the first line and more detailed information on\n   the following lines. Feel free to use Git's\n   [interactive rebase](https://help.github.com/articles/about-git-rebase/)\n   feature to tidy up your commits before making them public.\n\n5. Make sure all the tests are still passing.\n\n   ```bash\n   mix test\n   ```\n\n6. Push your topic branch up to your fork:\n\n   ```bash\n   git push origin  \n   ```\n\n7. [Open a Pull Request](https://help.github.com/articles/about-pull-requests/)\n    with a clear title and description.\n\n8. If you haven't updated your pull request for a while, you should consider\n   rebasing on master and resolving any conflicts.\n\n   **IMPORTANT**: _Never ever_ merge upstream `master` into your branches. You\n   should always `git rebase` on `master` to bring your changes up to date when\n   necessary.\n\n   ```bash\n   git checkout master\n   git pull upstream master\n   git checkout  \n   git rebase master\n   ```\n\nThank you for your contributions!","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Guides - Contributing","doc":"These Guides aim to be inclusive. We use \"we\" and \"our\" instead of \"you\" and\n\"your\" to foster this sense of inclusion.\n\nIdeally there is something for everybody in each guide, from beginner to expert.\nThis is hard, maybe impossible. When we need to compromise, we do so on behalf\nof beginning users because expert users have more tools at their disposal to\nhelp themselves.\n\nThe general pattern we use for presenting information is to first introduce a\nsmall, discrete topic, then write a small amount of code to demonstrate the\nconcept, then verify that the code worked.\n\nIn this way, we build from small, easily digestible concepts into more complex\nones. The shorter this cycle is, as long as the information is still clear and\ncomplete, the better.\n\nFor formatting the guides:\n\n- We use the `elixir` code fence for all module code.\n- We use the `iex` for IEx sessions.\n- We use the `console` code fence for shell commands.\n- We use the `html` code fence for html templates, even if there is elixir code\n  in the template.\n- We use backticks for filenames and directory paths.\n- We use backticks for module names, function names, and variable names.\n- Documentation line length should hard wrapped at around 100 characters if possible.","ref":"contributing.html#guides"},{"type":"extras","title":"Contributor Code of Conduct","doc":"# Contributor Code of Conduct\n\nAs contributors and maintainers of this project, and in the interest of fostering an open and welcoming community, we pledge to respect all people who contribute through reporting issues, posting feature requests, updating documentation, submitting pull requests or patches, and other activities.\n\nWe are committed to making participation in this project a harassment-free experience for everyone, regardless of level of experience, gender, gender identity and expression, sexual orientation, disability, personal appearance, body size, race, ethnicity, age, religion, or nationality.\n\nExamples of unacceptable behavior by participants include:\n\n* The use of sexualized language or imagery\n* Personal attacks\n* Trolling or insulting/derogatory comments\n* Public or private harassment\n* Publishing other's private information, such as physical or electronic addresses, without explicit permission\n* Other unethical or unprofessional conduct.\n\nProject maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct. By adopting this Code of Conduct, project maintainers commit themselves to fairly and consistently applying these principles to every aspect of managing this project. Project maintainers who do not follow or enforce the Code of Conduct may be permanently removed from the project team.\n\nThis code of conduct applies both within project spaces and in public spaces when an individual is representing the project or its community.\n\nInstances of abusive, harassing, or otherwise unacceptable behavior may be reported by opening an issue or contacting one or more of the project maintainers.\n\nThis Code of Conduct is adapted from the [Contributor Covenant](https://www.contributor-covenant.org), version 1.2.0, available at [https://www.contributor-covenant.org/version/1/2/0/code-of-conduct/](https://www.contributor-covenant.org/version/1/2/0/code-of-conduct/)","ref":"code_of_conduct.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}